
/*
 *@@sourcefile anos2ptr.c:
 *      This file contains SOM code for the following XWorkplace classes:
 *
 *      -- XWPOS2Pointer: WPDataFile subclass for OS/2 *.ptr files.
 *
 *@@added V0.9.3 (2000-05-21) [umoeller]
 *@@somclass XWPOS2Pointer o2p_
 *@@somclass M_XWPOS2Pointer o2pM_
 */

/*
 *      Copyright (C) 1995-2000 Christian langanke.
 *      Copyright (C) 2000 Ulrich Mller.
 *      This file is part of the XWorkplace source package.
 *      XWorkplace is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published
 *      by the Free Software Foundation, in version 2 as it comes in the
 *      "COPYING" file of the XWorkplace main distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */

/*
 *  This file was generated by the SOM Compiler and Emitter Framework.
 *  Generated using:
 *      SOM Emitter emitctm: 2.41
 */

#ifndef SOM_Module_anos2ptr_Source
#define SOM_Module_anos2ptr_Source
#endif
#define XWPOS2Pointer_Class_Source
#define M_XWPOS2Pointer_Class_Source

#pragma strings(readonly)

/*
 *  Suggested #include order:
 *  1)  os2.h
 *  2)  C library headers
 *  3)  setup.h (code generation and debugging options)
 *  4)  headers in helpers\
 *  5)  at least one SOM implementation header (*.ih)
 *  6)  dlgids.h, headers in shared\ (as needed)
 *  7)  headers in implementation dirs (e.g. filesys\, as needed)
 *  8)  #pragma hdrstop and then more SOM headers which crash with precompiled headers
 */

#define INCL_DOSERRORS
#define INCL_DOS
#define INCL_WIN
#define INCL_GPIBITMAPS
#include <os2.h>

// C library headers

// generic headers
#include "setup.h"                      // code generation and debugging options

// headers in /helpers

// SOM headers which don't crash with prec. header files
#include "anos2ptr.ih"

// XWorkplace implementation headers
#include "dlgids.h"                     // all the IDs that are shared with NLS
#include "shared\common.h"              // the majestic XWorkplace include file
#include "shared\kernel.h"              // XWorkplace Kernel

// own includes
#include "pointers\clstype.h"
#include "pointers\pointer.h"
#include "pointers\filetype.h"
#include "pointers\debug.h"
#include "pointers\info.h"
#include "pointers\warp4.h"
#include "pointers\macros.h"
#include "pointers\mptrptr.h"
#include "pointers\mptrppl.h"
#include "..\..\001\dll\r_amptr001.h"
#include "pointers\mptrutil.h"
#include "pointers\mptrcnr.h"

// ids
#define ANIMATION_TIMER_ID   256
#define ANIMATION_TIMEOUT    150L

// prototypes
MRESULT EXPENTRY wpo2p_NotebookPageProc(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2);

// other SOM headers
#pragma hdrstop

/*
 *@@ xwpRefreshFileIcon:
 *
 */

SOM_Scope void SOMLINK o2p_xwpRefreshFileIcon(XWPOS2Pointer * somSelf)
{

    APIRET rc = NO_ERROR;
    BOOL fSuccess = FALSE;
    ULONG i;
    CHAR szFilename[_MAX_PATH];
    ICONINFO iconinfo;
    PBYTE pbIconData;
    HPOINTER hptr = NULLHANDLE;

    FDATE fdateCurrentLastWrite;
    FTIME ftimeCurrentLastWrite;
    ULONG ulTimeout;
    HAB hab = WinInitialize(0);
    BOOL fIsFileModified;

    HPOINTER ahptr[MAX_COUNT_POINTERS];
    ULONG aulTimeout[MAX_COUNT_POINTERS];
    ULONG ulEntries = MAX_COUNT_POINTERS;
    ULONG ulTableLen;

    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_xwpRefreshFileIcon");
    FUNCENTER();

    do
    {

        // Dateiname ermitteln
        _wpQueryFilename(somSelf, szFilename, TRUE);

        // Datei vergleichen
        DosEnterCritSec();
        fIsFileModified = IsFileModified(szFilename, _pfs3);
        DosExitCritSec();
        if (!fIsFileModified)
            break;

        // fremdes Format laden
        memset(&iconinfo, 0, sizeof(iconinfo));
        fSuccess = LoadFirstPointerFromPointerFile(szFilename, &hptr, &iconinfo);

        if (!fSuccess)
            break;

        // Icon sichern
        if (hptr)
        {
            // handle setzen
            _wpSetIconHandle(somSelf, hptr);
            XWPOS2Pointer_parent_WPDataFile_wpSetIcon(somSelf, hptr);

            // handle fr Zugriffsfunktionen sichern
            if (_hptr)
            {
                WinDestroyPointer(_hptr);
                _hptr = 0;
            }

            // save hptr
            _hptr = hptr;
        }

        // jetzt Speicherbereich fr Struktur und Daten holen
        if (_piconinfo)
            _wpFreeMem(somSelf, (PBYTE)_piconinfo);
        _ulDataLen = iconinfo.cb + iconinfo.cbIconData;
        _piconinfo = (ICONINFO*)_wpAllocMem(somSelf, _ulDataLen, &rc);
        if (_piconinfo == NULL)
            _ulDataLen = 0;
        else
        {
            // Daten in Objektspeicher kopieren
            memset(_piconinfo, 0, _ulDataLen);
            pbIconData = (PBYTE) _piconinfo + iconinfo.cb;  // Neue Adresse der Binrdaten ermitteln

            memcpy(_piconinfo, &iconinfo, iconinfo.cb);     // Struktur kopieren

            memcpy(pbIconData, iconinfo.pIconData, iconinfo.cbIconData);    // Binrdaten anhngen

            _piconinfo->pIconData = pbIconData;     // Adresse Binrdaten eintragen

        }

        // temporren Speicher freigeben
        if (iconinfo.pIconData)
            free(iconinfo.pIconData);

        // jetzt Animation laden
        memset(ahptr, 0, sizeof(ahptr));
        memset(aulTimeout, 0, sizeof(aulTimeout));
        fSuccess = LoadFirstAnimationFromPointerFile(szFilename,
                                                     ahptr,
                                                     aulTimeout,
                                                     &ulEntries);
        if ((fSuccess) && (ulEntries > 1))
        {
            ulTableLen = ulEntries * sizeof(HPOINTER);
            _phpointerTable = (HPOINTER*)_wpAllocMem(somSelf, ulTableLen, &rc);
            _pulTimeoutTable = (ULONG*)_wpAllocMem(somSelf, ulTableLen, &rc);
            if (_phpointerTable)
            {
                memcpy(_phpointerTable, ahptr, ulTableLen);
                _ulAnimationCount = ulEntries;
            }
            if (_pulTimeoutTable)
                memcpy(_pulTimeoutTable, aulTimeout, ulTableLen);
        }


    }
    while (FALSE);

    if (hab)
        WinTerminate(hab);

    return;
}

/*
 *@@ xwpGetAnimationTimeframeValue:
 *
 */

SOM_Scope ULONG SOMLINK o2p_xwpGetAnimationTimeframeValue(XWPOS2Pointer * somSelf)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_xwpGetAnimationTimeframeValue");
    FUNCENTER();

    // @@todo
    return 0;
}

/*
 *@@ xwpSetAnimationTimeframeValue:
 *
 */

SOM_Scope BOOL SOMLINK o2p_xwpSetAnimationTimeframeValue(XWPOS2Pointer * somSelf,
                                                         ULONG ulNewValue)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_xwpSetAnimationTimeframeValue");
    FUNCENTER();

    // @@todo
    return TRUE;
}

/*
 *@@ xwpInsertAnimationPage1:
 *
 */

SOM_Scope ULONG SOMLINK o2p_xwpInsertAnimationPage1(XWPOS2Pointer * somSelf,
                                                  HWND hwndDlg)
{
    PAGEINFO pi;
    CHAR szTabName[MAX_RES_STRLEN];
    HAB hab = WinQueryAnchorBlock(HWND_DESKTOP);
    HMODULE hmodResource = cmnQueryNLSModuleHandle(FALSE); // V0.9.3 (2000-05-21) [umoeller]

    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_xwpInsertAnimationPage");
    FUNCENTER();

    LOADSTRING(IDTAB_NBANIMATION, szTabName);

    memset((PCH) & pi, 0, sizeof(PAGEINFO));
    pi.cb = sizeof(PAGEINFO);
    pi.hwndPage = NULLHANDLE;
    pi.usPageStyleFlags = BKA_MAJOR;
    pi.usPageInsertFlags = BKA_FIRST;
    pi.usSettingsFlags = SETTINGS_PAGE_NUMBERS;
    pi.pfnwp = wpo2p_NotebookPageProc;
    pi.resid = hmodResource;
    pi.dlgid = IsWARP3()? IDDLG_DLG_ANIMATIONPAGE1_230 : IDDLG_DLG_ANIMATIONPAGE1;
    pi.pszName = szTabName;
    pi.pCreateParams = somSelf;
    pi.idDefaultHelpPanel = 1; // IDPNL_USAGE_NBPAGE;
    pi.pszHelpLibraryName = (PSZ)cmnQueryHelpLibrary(); // V0.9.3 (2000-05-21) [umoeller]

    return _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

}

/*
 *@@ xwpInsertAnimationPage2:
 *
 */

SOM_Scope ULONG SOMLINK o2p_xwpInsertAnimationPage2(XWPOS2Pointer * somSelf,
                                                  HWND hwndDlg)
{
    PAGEINFO pi;
    CHAR szTabName[MAX_RES_STRLEN];
    HAB hab = WinQueryAnchorBlock(HWND_DESKTOP);
    HMODULE hmodResource = cmnQueryNLSModuleHandle(FALSE); // V0.9.3 (2000-05-21) [umoeller]

    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_xwpInsertAnimationPage2");

    FUNCENTER();

    LOADSTRING(IDTAB_NBANIMATION, szTabName);

    memset((PCH) & pi, 0, sizeof(PAGEINFO));
    pi.cb = sizeof(PAGEINFO);
    pi.hwndPage = NULLHANDLE;
    pi.usPageStyleFlags = BKA_MINOR;
    pi.usPageInsertFlags = BKA_FIRST;
    pi.usSettingsFlags = SETTINGS_PAGE_NUMBERS;
    pi.pfnwp = wpo2p_NotebookPageProc;
    pi.resid = hmodResource;
    pi.dlgid = IsWARP3()? IDDLG_DLG_ANIMATIONPAGE2_230 : IDDLG_DLG_ANIMATIONPAGE2;
    pi.pszName = szTabName;
    pi.pCreateParams = somSelf;
    pi.idDefaultHelpPanel = 1; // IDPNL_USAGE_NBPAGE;
    pi.pszHelpLibraryName = (PSZ)cmnQueryHelpLibrary(); // V0.9.3 (2000-05-21) [umoeller]

    return _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

}

/*
 *@@ xwpInsertAnimationPage3:
 *
 */

SOM_Scope ULONG SOMLINK o2p_xwpInsertAnimationPage3(XWPOS2Pointer * somSelf,
                                                  HWND hwndDlg)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_xwpInsertAnimationPage3");

    /* Return statement to be customized: */
    return (0);
}

/*
 *@@ wpAddFile1Page:
 *
 */

SOM_Scope ULONG SOMLINK o2p_wpAddFile1Page(XWPOS2Pointer * somSelf,
                                            HWND hwndNotebook)
{
    ULONG ulResult;
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpAddFile1Page");

    _xwpInsertAnimationPage2(somSelf, hwndNotebook);
    _xwpInsertAnimationPage1(somSelf, hwndNotebook);

    ulResult = XWPOS2Pointer_parent_WPDataFile_wpAddFile1Page(somSelf,
                                                             hwndNotebook);

    return ulResult;

}

/*
 *@@ wpAddObjectGeneralPage:
 *
 */

SOM_Scope ULONG SOMLINK o2p_wpAddObjectGeneralPage(XWPOS2Pointer * somSelf,
                                                    HWND hwndNotebook)
{
    PAGEINFO pi;
    CHAR szTabName[MAX_RES_STRLEN];
    HAB hab = WinQueryAnchorBlock(HWND_DESKTOP);
    HMODULE hmodResource = cmnQueryNLSModuleHandle(FALSE); // V0.9.3 (2000-05-21) [umoeller]

    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpAddObjectGeneralPage");
    FUNCENTER();

    LOADSTRING(IsWARP3()? IDTAB_NBGENERAL_230 : IDTAB_NBGENERAL, szTabName);

    memset((PCH) & pi, 0, sizeof(PAGEINFO));
    pi.cb = sizeof(PAGEINFO);
    pi.hwndPage = NULLHANDLE;
    pi.usPageStyleFlags = BKA_MAJOR;
    pi.usPageInsertFlags = BKA_FIRST;
    pi.usSettingsFlags = SETTINGS_PAGE_NUMBERS;
    pi.pfnwp = wpo2p_NotebookPageProc;
    pi.resid = hmodResource;
    pi.dlgid = IsWARP3()? IDDLG_DLG_ICONPAGE_230 : IDDLG_DLG_ICONPAGE;
    pi.pszName = szTabName;
    pi.pCreateParams = somSelf;
    pi.idDefaultHelpPanel = 1; // IDPNL_USAGE_NBPAGE;
    pi.pszHelpLibraryName = (PSZ)cmnQueryHelpLibrary(); // V0.9.3 (2000-05-21) [umoeller]

    return _wpInsertSettingsPage(somSelf, hwndNotebook, &pi);

}

/*
 *@@ wpObjectReady:
 *      this WPObject notification method gets called by the
 *      WPS when object instantiation is complete, for any reason.
 *      ulCode and refObject signify why and where from the
 *      object was created.
 *      The parent method must be called first.
 *
 *      See XFldObject::wpObjectReady for remarks about using
 *      this method as a copy constructor.
 */

SOM_Scope void SOMLINK o2p_wpObjectReady(XWPOS2Pointer * somSelf,
                                          ULONG ulCode, WPObject * refObject)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpObjectReady");
    FUNCENTER();

    XWPOS2Pointer_parent_WPDataFile_wpObjectReady(somSelf, ulCode,
                                                 refObject);

    // fremdes Iconformat erstmalig laden
    _xwpRefreshFileIcon(somSelf);
}

/*
 *@@ wpQueryIcon:
 *
 */

SOM_Scope HPOINTER SOMLINK o2p_wpQueryIcon(XWPOS2Pointer * somSelf)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpQueryIcon");
    FUNCENTER();

    // Icon erneuern
    _xwpRefreshFileIcon(somSelf);

    if (_hptr)
        return _hptr;

    return (XWPOS2Pointer_parent_WPDataFile_wpQueryIcon(somSelf));
}

/*
 *@@ wpQueryIconData:
 *
 */

SOM_Scope ULONG SOMLINK o2p_wpQueryIconData(XWPOS2Pointer * somSelf,
                                             PICONINFO pIconInfo)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpQueryIconData");
    FUNCENTER();

    // ACHTUNG: kein Refresh durchfhren, das passiert bereits durch wpQueryIcon

    // WPS ruft diese Funktion wie folgt auf
    // - 1. Call: pIconInfo = NULL, nur Rckgabe der Lnge
    // - 1. Call: pIconInfo = ptr,  Abfrage der Datan
    if (_ulDataLen)
    {
        if (pIconInfo)
            memcpy(pIconInfo, _piconinfo, sizeof(ICONINFO));
        return _ulDataLen;
    }

    return (XWPOS2Pointer_parent_WPDataFile_wpQueryIconData(somSelf,
                                                           pIconInfo));
}

/*
 *@@ wpSetIcon:
 *
 */

SOM_Scope BOOL SOMLINK o2p_wpSetIcon(XWPOS2Pointer * somSelf,
                                      HPOINTER hptrNewIcon)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpSetIcon");
    FUNCENTER();

    // don't set other icon than our own
    if (_hptr)
        hptrNewIcon = _hptr;

    return (XWPOS2Pointer_parent_WPDataFile_wpSetIcon(somSelf,
                                                     hptrNewIcon));
}

/*
 *@@ wpSetIconData:
 *
 */

SOM_Scope BOOL SOMLINK o2p_wpSetIconData(XWPOS2Pointer * somSelf,
                                          PICONINFO pIconInfo)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpSetIconData");
    FUNCENTER();

    // don't set icon data
    if (_ulDataLen)
    {
        DEBUGMSG("info: alarm: setIconFaked" NEWLINE, 0);
        WinAlarm(HWND_DESKTOP, WA_ERROR);
        return TRUE;
    }

    return (XWPOS2Pointer_parent_WPDataFile_wpSetIconData(somSelf,
                                                         pIconInfo));
}

/*
 *@@ wpModifyPopupMenu:
 *
 */

SOM_Scope BOOL SOMLINK o2p_wpModifyPopupMenu(XWPOS2Pointer * somSelf,
                                              HWND hwndMenu,
                                              HWND hwndCnr,
                                              ULONG iPosition)
{
    BOOL fSuccess = TRUE;
    APIRET rc = NO_ERROR;
    CHAR szFilename[_MAX_PATH];

    ULONG ulSourceFileType;
    PSZ pszFileExtension;
    ULONG ulDeleteItem = 0;
    ULONG ulPointerIndex;

    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpModifyPopupMenu");
    FUNCENTER();

    // Submen an das Ende anhngen
    // - Position 0 ist am Ende des Mens
    // - Separator wird selbststndig eingefgt

    fSuccess =
        _wpInsertPopupMenuItems(somSelf, hwndMenu, 0,
                                cmnQueryNLSModuleHandle(FALSE), // _clsQueryResourceModuleHandle(_XWPOS2Pointer), V0.9.3 (2000-05-21) [umoeller]
                                IDMEN_CONVERT_MENU, WPMENUID_PRIMARY);

    if (fSuccess)
    {
        do
        {
            // Dateiname und Quelldateityp ermitteln
            _wpQueryFilename(somSelf, szFilename, TRUE);
            pszFileExtension = Filespec(szFilename, FILESPEC_EXTENSION);
            if (!pszFileExtension)
                break;

            strupr(pszFileExtension);
            // DEBUGMSG( "--- file ext: %s" NEWLINE, pszFileExtension);
            if (!QueryResFileTypeFromExt(pszFileExtension, &ulSourceFileType))
                break;

            // DEBUGMSG( "--- file type: %u" NEWLINE, ulSourceFileType);
            // Konvertierung auf eigenen Dateityp ausschlien
            switch (ulSourceFileType)
            {
                case RESFILETYPE_POINTER:
                    ulDeleteItem = IDMEN_CONVERT_POINTER;
                    break;
                case RESFILETYPE_CURSOR:
                    ulDeleteItem = IDMEN_CONVERT_CURSOR;
                    break;
                case RESFILETYPE_WINANIMATION:
                    ulDeleteItem = IDMEN_CONVERT_WINANIMATION;
                    break;
                case RESFILETYPE_ANIMOUSE:
                    ulDeleteItem = IDMEN_CONVERT_ANIMOUSE;
                    break;
            }
            if (ulDeleteItem)
                WinSendMsg(hwndMenu, MM_DELETEITEM, MPFROM2SHORT(ulDeleteItem, TRUE), 0);

            //
            switch (ulSourceFileType)
            {
                case RESFILETYPE_POINTER:
                case RESFILETYPE_CURSOR:
                case RESFILETYPE_WINANIMATION:

                    // DEBUGMSG( "--- check for pointername" NEWLINE, 0);
                    if (!IsFilenameValid(szFilename, FILENAME_CONTAINSPOINTERNAME, &ulPointerIndex))
                        WinSendMsg(hwndMenu, MM_DELETEITEM, MPFROM2SHORT(IDMEN_CONVERT_ANIMOUSE, TRUE), 0);

            }


        }
        while (FALSE);

    }

    return (XWPOS2Pointer_parent_WPDataFile_wpModifyPopupMenu(somSelf,
                                                             hwndMenu,
                                                             hwndCnr,
                                                             iPosition));
}

/*
 *@@ wpFilterPopupMenu:
 *
 */

SOM_Scope ULONG SOMLINK o2p_wpFilterPopupMenu(XWPOS2Pointer * somSelf,
                                               ULONG ulFlags,
                                               HWND hwndCnr,
                                               BOOL fMultiSelect)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpFilterPopupMenu");

    ulFlags &= ~CTXT_PRINT;

    return (XWPOS2Pointer_parent_WPDataFile_wpFilterPopupMenu(somSelf,
                                                             ulFlags,
                                                             hwndCnr,
                                                             fMultiSelect));
}

/*
 *@@ wpMenuItemSelected:
 *      this WPObject method processes menu selections.
 *      This must be overridden to support new menu
 *      items which have been added in wpModifyPopupMenu.
 *
 *      See XFldObject::wpMenuItemSelected for additional
 *      remarks.
 */

SOM_Scope BOOL SOMLINK o2p_wpMenuItemSelected(XWPOS2Pointer * somSelf,
                                               HWND hwndFrame,
                                               ULONG ulMenuId)
{

    ULONG ulTargetFileType = 0;
    CHAR szFilename[_MAX_PATH];
    APIRET rc = NO_ERROR;

    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpMenuItemSelected");
    FUNCENTER();

    switch (ulMenuId)
    {
        case IDMEN_CONVERT_POINTER:
            ulTargetFileType = RESFILETYPE_POINTER;
            break;
        case IDMEN_CONVERT_CURSOR:
            ulTargetFileType = RESFILETYPE_CURSOR;
            break;
        case IDMEN_CONVERT_WINANIMATION:
            ulTargetFileType = RESFILETYPE_WINANIMATION;
            break;
        case IDMEN_CONVERT_ANIMOUSE:
            ulTargetFileType = RESFILETYPE_ANIMOUSE;
            break;

        default:
            return (XWPOS2Pointer_parent_WPDataFile_wpMenuItemSelected(somSelf,
                                                                    hwndFrame,
                                                                   ulMenuId));
    }

    // Datei konvertiern
    _wpQueryFilename(somSelf, szFilename, TRUE);

    rc = ConvertFile(szFilename, ulTargetFileType);
    if (rc != NO_ERROR)
    {
        DEBUGMSG("error: alarm: could not convert file, rc=%u" NEWLINE, rc);
        WinAlarm(HWND_DESKTOP, WA_ERROR);
    }

    return TRUE;

}

/*
 *@@ wpMenuItemHelpSelected:
 *
 */

SOM_Scope BOOL SOMLINK o2p_wpMenuItemHelpSelected(XWPOS2Pointer * somSelf,
                                                   ULONG MenuId)
{
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpMenuItemHelpSelected");
    FUNCENTER();

    // @@todo
    return (XWPOS2Pointer_parent_WPDataFile_wpMenuItemHelpSelected(somSelf,
                                                                  MenuId));
}

/*
 *@@ wpInitData:
 *
 */

SOM_Scope void SOMLINK o2p_wpInitData(XWPOS2Pointer * somSelf)
{
    APIRET rc;
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpInitData");
    FUNCENTER();

    XWPOS2Pointer_parent_WPDataFile_wpInitData(somSelf);

    do
    {
        // Variablen initialisieren
        _piconinfo = NULL;
        _hptr = NULLHANDLE;
        _ulDataLen = 0;
        _pfs3 = _wpAllocMem(somSelf, sizeof(FILESTATUS3), &rc);
        if (_pfs3)
            memset(_pfs3, 0, sizeof(FILESTATUS3));

        _phpointerTable = NULL;
        _pulTimeoutTable = NULL;
        _ulAnimationCount = 0;

    }
    while (FALSE);              // end do

}

/*
 *@@ wpUnInitData:
 *
 */

SOM_Scope void SOMLINK o2p_wpUnInitData(XWPOS2Pointer * somSelf)
{
    ULONG i;
    XWPOS2PointerData *somThis = XWPOS2PointerGetData(somSelf);

    XWPOS2PointerMethodDebug("XWPOS2Pointer", "o2p_wpUnInitData");
    FUNCENTER();

    XWPOS2Pointer_parent_WPDataFile_wpUnInitData(somSelf);   // @@todo

    // Speicher freigeben
    if (_piconinfo)
        _wpFreeMem(somSelf, (PBYTE)_piconinfo);
    if (_pfs3)
        _wpFreeMem(somSelf, _pfs3);
    if (_hptr)
        WinDestroyPointer(_hptr);

    for (i = 0; i < _ulAnimationCount; i++)
    {
        WinDestroyPointer(*(_phpointerTable + i));
    }

    if (_phpointerTable)
        _wpFreeMem(somSelf, (PBYTE)_phpointerTable);
    if (_pulTimeoutTable)
        _wpFreeMem(somSelf, (PBYTE)_pulTimeoutTable);

    XWPOS2Pointer_parent_WPDataFile_wpUnInitData(somSelf);
}

/*
 *@@ wpclsQueryStyle:
 *
 */

SOM_Scope ULONG SOMLINK o2pM_wpclsQueryStyle(M_XWPOS2Pointer * somSelf)
{
    // M_XWPOS2PointerData *somThis = M_XWPOS2PointerGetData(somSelf);

    M_XWPOS2PointerMethodDebug("M_XWPOS2Pointer", "o2pM_wpclsQueryStyle");

    return (M_XWPOS2Pointer_parent_M_WPDataFile_wpclsQueryStyle(somSelf) & CLSSTYLE_NEVERTEMPLATE);
}

/*
 *@@ wpclsQueryInstanceFilter:
 *
 */

SOM_Scope PSZ SOMLINK o2pM_wpclsQueryInstanceFilter(M_XWPOS2Pointer * somSelf)
{
    /* M_XWPOS2PointerData *somThis = M_XWPOS2PointerGetData(somSelf); */
    M_XWPOS2PointerMethodDebug("M_XWPOS2Pointer", "o2pM_wpclsQueryInstanceFilter");
    FUNCENTER();

    return (FILEFILTER_POINTER);
}

/*
 *@@ wpclsQueryInstanceType:
 *
 */

SOM_Scope PSZ SOMLINK o2pM_wpclsQueryInstanceType(M_XWPOS2Pointer * somSelf)
{
    /* M_XWPOS2PointerData *somThis = M_XWPOS2PointerGetData(somSelf); */
    M_XWPOS2PointerMethodDebug("M_XWPOS2Pointer", "o2pM_wpclsQueryInstanceType");
    FUNCENTER();

    return (FILETYPE_POINTER);
}

/*
 *@@ wpclsQueryTitle:
 *      this WPObject class method tells the WPS the clear
 *      name of a class, which is shown in the third column
 *      of a Details view and also used as the default title
 *      for new objects of a class.
 */

SOM_Scope PSZ SOMLINK o2pM_wpclsQueryTitle(M_XWPOS2Pointer * somSelf)
{
    /* M_XWPOS2PointerData *somThis = M_XWPOS2PointerGetData(somSelf); */
    M_XWPOS2PointerMethodDebug("M_XWPOS2Pointer", "o2pM_wpclsQueryTitle");
    FUNCENTER();

    return (FILETYPE_POINTER);
}

/*
 *@@ wpclsInitData:
 *
 */

SOM_Scope void SOMLINK o2pM_wpclsInitData(M_XWPOS2Pointer * somSelf)
{
    APIRET rc;

    // M_XWPOS2PointerData *somThis = M_XWPOS2PointerGetData(somSelf);

    M_XWPOS2PointerMethodDebug("M_XWPOS2Pointer", "o2pM_wpclsInitData");
    FUNCENTER();

    M_XWPOS2Pointer_parent_M_WPDataFile_wpclsInitData(somSelf);

    /* // Load res module
    rc = LoadResourceLib(&_hmodResource);

    // reload class lib, so that it is available for static links
    rc = ReloadClassLib(&_hmodClassLib);

    // retrieve help library name
    rc = GetHelpLibName(_szHelpLibrary, sizeof(_szHelpLibrary)); */

}

/*
 *@@ wpclsUnInitData:
 *
 */

SOM_Scope void SOMLINK o2pM_wpclsUnInitData(M_XWPOS2Pointer * somSelf)
{

    APIRET rc;

    // M_XWPOS2PointerData *somThis = M_XWPOS2PointerGetData(somSelf);

    M_XWPOS2PointerMethodDebug("M_XWPOS2Pointer", "o2pM_wpclsUnInitData");
    FUNCENTER();

    // Unload resource DLL
    /* if (_hmodResource)
    {
        rc = DosFreeModule(_hmodResource);
        _hmodResource = NULLHANDLE;
    }

    if (_hmodClassLib)
    {
        rc = DosFreeModule(_hmodClassLib);
        _hmodClassLib = NULLHANDLE;
    } */


    M_XWPOS2Pointer_parent_M_WPDataFile_wpclsUnInitData(somSelf);
}

/*
 *@@ WPSWINDOWDATA:
 *
 *@@added V [umoeller]
 */

typedef struct _WPSWINDOWDATA
{
    HMODULE hmodResource;
    SOMAny *somSelf;
    ULONG ulAnimationTimerId;
    ULONG ulPtrIndex;
}
WPSWINDOWDATA, *PWPSWINDOWDATA;


/*
 *@@ wpo2p_NotebookPageProc:
 *
 */

MRESULT EXPENTRY wpo2p_NotebookPageProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{

    PWPSWINDOWDATA pwd = WinQueryWindowPtr(hwnd, QWL_USER);
    SOMAny *somSelf;
    XWPOS2PointerData *somThis;
    APIRET rc = NO_ERROR;
    // BOOL fSuccess = FALSE;
    USHORT usPageId = WinQueryWindowUShort(hwnd, QWS_ID);
    HAB hab = WinQueryAnchorBlock(hwnd);

    if (pwd)
    {
        // Zugriff auf Klassenvariablen immer ermglichen
        somSelf = pwd->somSelf;
        somThis = XWPOS2PointerGetData(somSelf);
    }

    switch (msg)

    {

        case WM_INITDLG:
            {
                PFNWP pfnwpOriginal;

                // store windowdata
                pwd = malloc(sizeof(WPSWINDOWDATA));
                memset(pwd, 0, sizeof(WPSWINDOWDATA));
                pwd->somSelf = (SOMAny *) mp2;
                WinSetWindowPtr(hwnd, QWL_USER, pwd);
                somSelf = pwd->somSelf;
                somThis = XWPOS2PointerGetData(somSelf);

                // Resource Module handle speichern
                pwd->hmodResource = cmnQueryNLSModuleHandle(FALSE); // V0.9.3 (2000-05-21) [umoeller]

                if (usPageId == IDDLG_DLG_ICONPAGE)
                {
                    HWND hwndIcon = WinWindowFromID(hwnd, IDDLG_IC_CONTENTS);
                    HWND hwndGB = WinWindowFromID(hwnd, IDDLG_GB_CONTENTS);
                    SWP swpGB;

                    // fr icon page den Stil extra fr UNDO sichern
                    _ulLastStyle = _wpQueryStyle(somSelf);

                    // static text fr ICON  auf SS_ICON ndern
                    WinSetWindowULong(hwndIcon,
                                      QWL_STYLE,
                                      WinQueryWindowULong(hwndIcon,
                                                        QWL_STYLE) | SS_ICON);

                    // Window subclassen fr sauberes redraw
                    WinSubclassWindow(hwndIcon, SubclassStaticWindowProc);

                    // ICON innerhalb der Groupbox positionieren
                    if (WinQueryWindowPos(hwndGB, &swpGB))
                    {
                        WinSetWindowPos(hwndIcon, HWND_TOP,
                                        swpGB.x + ((swpGB.cx - 32) / 2),
                                        swpGB.y + ((swpGB.cy - 32) / 2),
                                        32, 32,
                                        SWP_MOVE | SWP_SIZE);
                    }

                    // ggfs. Animation starten
                    if (_ulAnimationCount > 1)
                    {
                        WinSendMsg(hwnd, WM_TIMER, MPFROMLONG(ANIMATION_TIMER_ID), 0);
                        pwd->ulAnimationTimerId = WinStartTimer(hab, hwnd, ANIMATION_TIMER_ID, ANIMATION_TIMEOUT);  // timeout value

                    }

                }

                // Controls der Seite initialisieren
                WinSendMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDDLG_PB_UNDO, 0), 0L);
            }
            break;              // case WM_INITDLG:


            // --------------------------------------------------------------------------

        case WM_TIMER:
            {
                ULONG ulTimerId = SHORT1FROMMP(mp1);
                HWND hwndIcon = WinWindowFromID(hwnd, IDDLG_IC_CONTENTS);
                HPOINTER hptr;
                ULONG ulTimeout;

                if ((ulTimerId == ANIMATION_TIMER_ID) && (WinIsWindowVisible(hwndIcon)))
                {
                    // stop the timer
                    WinStopTimer(hab, hwnd, ANIMATION_TIMER_ID);

                    // set new handle
                    hptr = *(_phpointerTable + pwd->ulPtrIndex);
                    if (hptr)
                    {
                        WinSendMsg(hwndIcon, SM_SETHANDLE, MPFROMLONG(hptr), 0);
//          WinShowWindow( hwndIcon, FALSE);
                        //          WinShowWindow( hwndIcon, TRUE);
                    }

                    // preselect next icon
                    pwd->ulPtrIndex++;
                    if (pwd->ulPtrIndex >= _ulAnimationCount)
                        pwd->ulPtrIndex = 0;

                    // restart the timer
                    ulTimeout = *(_pulTimeoutTable + pwd->ulPtrIndex);
                    if (!ulTimeout)
                        ulTimeout = ANIMATION_TIMEOUT;
//       DEBUGMSG("--- index: %u timeout: %u" NEWLINE, pwd->ulPtrIndex _c_ ulTimeout);
                    pwd->ulAnimationTimerId = WinStartTimer(hab, hwnd, ANIMATION_TIMER_ID, ulTimeout);
                }
            }
            break;              // case WM_TIMER:

            // --------------------------------------------------------------------------

        case WM_CONTROL:

            switch (usPageId)
            {

                    // ...................................................................

                case IDDLG_DLG_ICONPAGE:
                    {
                        switch (SHORT1FROMMP(mp1))
                        {
                                ULONG ulStyle;
                                BOOL fCheck;

                            case IDDLG_CB_TEMPLATE:
                                {
                                    // query style
                                    ulStyle = _wpQueryStyle(somSelf);
                                    fCheck = DLGQUERYCHECK(hwnd, IDDLG_CB_TEMPLATE);
                                    if (fCheck)
                                        ulStyle |= OBJSTYLE_TEMPLATE;
                                    else
                                        ulStyle &= ~OBJSTYLE_TEMPLATE;
                                    _wpSetStyle(somSelf, ulStyle);

                                }
                                break;  // case IDDLG_CB_TEMPLATE:

                            case IDDLG_CB_LOCKPOS:
                                {
                                    // query style
                                    ulStyle = _wpQueryStyle(somSelf);
                                    fCheck = DLGQUERYCHECK(hwnd, IDDLG_CB_LOCKPOS);
                                    if (fCheck)
                                        ulStyle |= OBJSTYLE_LOCKEDINPLACE;
                                    else
                                        ulStyle &= ~OBJSTYLE_LOCKEDINPLACE;
                                    _wpSetStyle(somSelf, ulStyle);
                                }
                                break;  // case IDDLG_CB_LOCKPOS:

                        }       // switch (SHORT1FROMMP(mp1))

                    }
                    break;      // case IDDLG_DLG_ICONPAGE:

                    // ...................................................................


            }                   // switch (usPageId)

            break;              // case WM_CONTROL:


            // --------------------------------------------------------------------------

        case WM_COMMAND:

            switch (SHORT1FROMMP(mp1))
            {

                case IDDLG_PB_UNDO:

                    switch (usPageId)
                    {

                            // ...................................................................

                        case IDDLG_DLG_ANIMATIONPAGE1:
                            {
                                CHAR szFilename[_MAX_PATH];
                                ULONG ulSourceInfoLen = 0;
                                PSOURCEINFO psourceinfo = NULL;

                                do
                                {
                                    // Dateiname ermitteln
                                    _wpQueryFilename(somSelf, szFilename, TRUE);

                                    // Gre ermitteln
                                    QueryPointerFileDetails(szFilename, FI_SOURCEINFO, NULL, 0, &ulSourceInfoLen);
                                    // DEBUGMSG(" --- ulSourceInfoLen=%u" NEWLINE, ulSourceInfoLen);
                                    if (!ulSourceInfoLen)
                                        break;

                                    if ((psourceinfo = malloc(ulSourceInfoLen)) == NULL)
                                    {
                                        rc = ERROR_NOT_ENOUGH_MEMORY;
                                        break;
                                    }

                                    // sourceinfo holen und in die Eingabefelder bringen
                                    rc = QueryPointerFileDetails(szFilename, FI_SOURCEINFO, psourceinfo, ulSourceInfoLen, &ulSourceInfoLen);
                                    // DEBUGMSG(" --- query sourceinfo rc=%u" NEWLINE, rc);
                                    DLGSETSTRING(hwnd, IDDLG_EF_INFONAME, psourceinfo->pszInfoName);
                                    DLGSETSTRING(hwnd, IDDLG_EF_INFOARTIST, psourceinfo->pszInfoArtist);
                                    // mark filter fields as unchanged
                                    DLGQUERYCHANGED(hwnd, IDDLG_EF_INFONAME);
                                    DLGQUERYCHANGED(hwnd, IDDLG_EF_INFOARTIST);

                                }
                                while (FALSE);

                                // report error
                                if (rc != NO_ERROR)
                                {
                                    DEBUGMSG("error: alarm: could not query source info, rc=%u" NEWLINE, rc);
                                    WinAlarm(HWND_DESKTOP, WA_ERROR);
                                }
                                if (psourceinfo)
                                    free(psourceinfo);

                            }
                            break;  // case IDDLG_DLG_ANIMATIONPAGE1:

                            // ...................................................................

                        case IDDLG_DLG_ICONPAGE:
                            {
                                ULONG ulStyle;

                                // set title
                                DLGSETSTRING(hwnd, IDDLG_ME_TITLE, _wpQueryTitle(somSelf));

                                // mark title field as unchanged
                                DLGQUERYCHANGED(hwnd, IDDLG_ME_TITLE);

                                // query style and undo !
                                ulStyle = _ulLastStyle;
                                DLGSETCHECK(hwnd, IDDLG_CB_TEMPLATE, ((ulStyle & OBJSTYLE_TEMPLATE) != 0));
                                DLGSETCHECK(hwnd, IDDLG_CB_LOCKPOS, ((ulStyle & OBJSTYLE_LOCKEDINPLACE) != 0));
                                _wpSetStyle(somSelf, _ulLastStyle);

                                // set bitmap for icon, if not animated
                                if (!pwd->ulAnimationTimerId)
                                    WinSendDlgItemMsg(hwnd, IDDLG_IC_CONTENTS, SM_SETHANDLE, MPFROMLONG(_hptr), 0);
                            }
                            break;  // case IDDLG_DLG_ICONPAGE:

                            // ...................................................................


                    }           // switch (usPageId)


                    break;      // case IDDLG_PB_UNDO:

                case IDDLG_PB_DEFAULT:

                    switch (usPageId)
                    {

                            // ...................................................................

                        case IDDLG_DLG_ICONPAGE:
                            {
                                ULONG ulStyle;

                                // set title
                                DLGSETSTRING(hwnd, IDDLG_ME_TITLE, _wpclsQueryTitle(_XWPOS2Pointer));

                                // mark title field as unchanged
                                DLGQUERYCHANGED(hwnd, IDDLG_ME_TITLE);

                                // query style
                                ulStyle = _wpclsQueryStyle(_XWPOS2Pointer);
                                _wpSetStyle(somSelf, ulStyle);
                                DLGSETCHECK(hwnd, IDDLG_CB_TEMPLATE, (ulStyle & OBJSTYLE_TEMPLATE));
                                DLGSETCHECK(hwnd, IDDLG_CB_LOCKPOS, (ulStyle & OBJSTYLE_LOCKEDINPLACE));
                            }
                            break;  // case IDDLG_DLG_ICONPAGE:

                            // ...................................................................


                    }           // switch (usPageId)


                    break;      // case IDDLG_PB_UNDO:


            }                   // switch (SHORT1FROMMP(mp1))

            return ((MPARAM)TRUE);
            // break;              // case WM_COMMAND:

            // --------------------------------------------------------------------------

        case WM_DESTROY:
            {
                switch (usPageId)
                {

                        // ...................................................................

                    case IDDLG_DLG_ANIMATIONPAGE1:
                        {
                            CHAR szFilename[_MAX_PATH];
                            SOURCEINFO sourceinfo;
                            CHAR szInfoName0[_MAX_PATH];
                            CHAR szInfoArtist0[_MAX_PATH];

                            BOOL fNameChanged = DLGQUERYCHANGED(hwnd, IDDLG_EF_INFONAME);
                            BOOL fArtistChanged = DLGQUERYCHANGED(hwnd, IDDLG_EF_INFOARTIST);

                            if ((fNameChanged) || (fArtistChanged))
                            {
                                CHAR szInfoName[_MAX_PATH];
                                CHAR szInfoArtist[_MAX_PATH];

                                // initialisieren
                                memset(&sourceinfo, 0, sizeof(SOURCEINFO));

                                // Dateiname ermitteln
                                _wpQueryFilename(somSelf, szFilename, TRUE);

                                if (fNameChanged)
                                {
                                    DLGQUERYSTRING(hwnd, IDDLG_EF_INFONAME, szInfoName);
                                    sourceinfo.pszInfoName = szInfoName;
                                }

                                if (fArtistChanged)
                                {
                                    DLGQUERYSTRING(hwnd, IDDLG_EF_INFOARTIST, szInfoArtist);
                                    sourceinfo.pszInfoArtist = szInfoArtist;
                                }

                                // Attribute setzen
                                rc = SetPointerFileInfo(szFilename, &sourceinfo);
                                if (rc != NO_ERROR)
                                {
                                    DEBUGMSG("error: alarm: could not change source info, rc=%u" NEWLINE, rc);
                                    WinAlarm(HWND_DESKTOP, WA_ERROR);
                                }
                            }
                        }
                        break;  // case IDDLG_DLG_ANIMATIONPAGE1:

                        // ...................................................................

                    case IDDLG_DLG_ICONPAGE:
                        {
                            // stop timer
                            if (pwd->ulAnimationTimerId)
                                WinStopTimer(hab, hwnd, ANIMATION_TIMER_ID);

                            // save title
                            if (MLEQUERYCHANGED(hwnd, IDDLG_ME_TITLE))
                            {
                                CHAR szTitle[_MAX_PATH + 32];
                                BOOL fSuccess;

                                DLGQUERYSTRING(hwnd, IDDLG_ME_TITLE, szTitle);
                                fSuccess = _wpSetTitle(somSelf, szTitle);
                            }

                            // set handle to NULL, so that our handle is not destroyed
                            WinSendDlgItemMsg(hwnd, IDDLG_IC_CONTENTS, SM_SETHANDLE, 0, 0);

                        }
                        break;  // case IDDLG_DLG_ICONPAGE:


                }               // switch (usPageId)

            }
            break;              // case WM_DESTROY:

    }                           // switch (msg)

    return WinDefDlgProc(hwnd, msg, mp1, mp2);

}

